# @(#)91  1.5 src/cmdline/staging/scripts/modify_partner.py, amws.cmdline, fim611, 060921a 9/18/06 16:18:33
# (C) Copyright International Business Machines Corporation 2005. All rights
# reserved.  U.S. Government Users Restricted Rights -- Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 
from com.tivoli.am.fim.middlemanager.ssps import FederationManager, ConfigurationParameters, Partner
from fim_base import read_properties_file, commit_session
from fed_utils import get_federation, get_partner, show_partner, set_federation_properties
from domain_utils import is_domain_present
from com.tivoli.am.fim.logging import FIMLoggerFactory
from com.tivoli.am.fim.logging import FIMLogger
from com.tivoli.am.fim.logging import FIMLevel
from com.tivoli.am.fim.i18n.msgs import CmdLineMessages
from jarray import array
from java.lang import Object
from com.tivoli.am.fim.logging import FIMLoggerConstants

# Set up FIMLogger
component_name = "StagingTools"
script_name = "modify_partner.py"
method_name = script_name
class_name = "com.tivoli.am.fim.cmdline." + script_name[0:-3]
FIMLoggerFactory.enableStdout(FIMLevel.ALL)
FIMLoggerFactory.setPreferredFIMLoggerImpl(FIMLoggerConstants.FIMLOGGER_BASE_IMPL)
log = FIMLoggerFactory.getFIMLogger(component_name, class_name, CmdLineMessages.CLASS_NAME)

def usage():
    inserts = array([script_name],Object)
    log.logMessage(FIMLevel.INFO, method_name, CmdLineMessages.usage_modify_partner, \
        inserts)
    raise SystemExit

if __name__ == 'main':

    if len(sys.argv) < 4:
        usage()

    props_file = sys.argv[0]
    user_props_file = sys.argv[1]
    fed_name = sys.argv[2]
    partner_name = sys.argv[3]
    
    props = read_properties_file(props_file)
    if not is_domain_present(props):
        raise SystemExit
    
    # Get the federation object 
    (fed, fed_mgr) = get_federation(fed_name, props_file)    
    
    # Get the user-defined properties for the partner from the props file
    user_props = read_properties_file(user_props_file)

    # Check to see if partner exists and print results
    partner = get_partner(fed, partner_name)
    if partner:
        set_federation_properties(fed, user_props, partner)
        partner.updateEntity()   
        inserts = array([partner_name, fed_name], Object)
        log.logMessage(FIMLevel.INFO, method_name, \
            CmdLineMessages.modified_partner_successfully, inserts)
        commit_session(fed_mgr)
    else:
        inserts = array([partner_name, fed_name], Object)
        log.logMessage(FIMLevel.INFO, method_name, \
            CmdLineMessages.partner_does_not_exist, inserts)
        raise SystemExit

    raise SystemExit

